/**
 * JS Cookie
 */
!function(e){var n;if("function"==typeof define&&define.amd&&(define(e),n=!0),"object"==typeof exports&&(module.exports=e(),n=!0),!n){var t=window.Cookies,o=window.Cookies=e();o.noConflict=function(){return window.Cookies=t,o}}}(function(){function e(){for(var e=0,n={};e<arguments.length;e++){var t=arguments[e];for(var o in t)n[o]=t[o]}return n}function n(e){return e.replace(/(%[0-9A-Z]{2})+/g,decodeURIComponent)}return function t(o){function r(){}function i(n,t,i){if("undefined"!=typeof document){"number"==typeof(i=e({path:"/"},r.defaults,i)).expires&&(i.expires=new Date(1*new Date+864e5*i.expires)),i.expires=i.expires?i.expires.toUTCString():"";try{var c=JSON.stringify(t);/^[\{\[]/.test(c)&&(t=c)}catch(e){}t=o.write?o.write(t,n):encodeURIComponent(String(t)).replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g,decodeURIComponent),n=encodeURIComponent(String(n)).replace(/%(23|24|26|2B|5E|60|7C)/g,decodeURIComponent).replace(/[\(\)]/g,escape);var f="";for(var u in i)i[u]&&(f+="; "+u,!0!==i[u]&&(f+="="+i[u].split(";")[0]));return document.cookie=n+"="+t+f}}function c(e,t){if("undefined"!=typeof document){for(var r={},i=document.cookie?document.cookie.split("; "):[],c=0;c<i.length;c++){var f=i[c].split("="),u=f.slice(1).join("=");t||'"'!==u.charAt(0)||(u=u.slice(1,-1));try{var a=n(f[0]);if(u=(o.read||o)(u,a)||n(u),t)try{u=JSON.parse(u)}catch(e){}if(r[a]=u,e===a)break}catch(e){}}return e?r[e]:r}}return r.set=i,r.get=function(e){return c(e,!1)},r.getJSON=function(e){return c(e,!0)},r.remove=function(n,t){i(n,"",e(t,{expires:-1}))},r.defaults={},r.withConverter=t,r}(function(){})});

/**
 * Basic variables
 */

const currentLocationFree = window.location.href.split("#")[0];
const currentTimeFree = Date.now();
let winWidthFree = window.innerWidth;
let winHeightFree = window.innerHeight;

const ffDiscounthuntFreeCreateCORSRequest = (method, url) => {
	const xhr = new XMLHttpRequest();
	if ("withCredentials" in xhr) {
		xhr.open(method, url, true);
	} else if (typeof XDomainRequest != "undefined") {
		xhr = new XDomainRequest();
		xhr.open(method, url);
	} else {
		xhr = null;
	}
	return xhr;
}

/**
 * Handle discount hunt form submit
 */
const ffHandleDiscounthuntFormSubmitFree = (e) => {
  const ffDiscounthuntSubmitButton = document.querySelector("#ff-discounthunt-free-session-form__submit");
  const ffDiscounthuntSubmitButtonSpinner = ffDiscounthuntSubmitButton.querySelector("i");

  e.preventDefault();

  if(ffDiscounthuntFreeSessionPreview){
    // preview, instantly display result page
    document.querySelector("#ff-discounthunt-free-session-modal__form-container").classList.add("ff-discounthunt-free-session--hidden");
    document.querySelector("#ff-discounthunt-free-session-modal__description").classList.add("ff-discounthunt-free-session--hidden");
    document.querySelector("#ff-discounthunt-free-session-modal__result").classList.remove("ff-discounthunt-free-session--hidden");
    document.querySelector("#ff-discounthunt-free-session-modal__result-discountcode").innerHTML = "PREVIEW CODE";
    return;
  }

  /**
   * Check required fields
   */
  const firstNameField = document.querySelector("#ff-discounthunt-free-session-form__first-name");
  const lastNameField = document.querySelector("#ff-discounthunt-free-session-form__last-name");
  const emailField = document.querySelector("#ff-discounthunt-free-session-form__email");
  const additionalInformationField = document.querySelector("#ff-discounthunt-free-session-form__additional");
  const legalCheckbox = document.querySelector("#ff-discounthunt-free-session-form__legal");

  const ffDiscounthuntHunterData = {
    huntSession: ffDiscounthuntFreeSessionData.id,
    firstName: firstNameField.value,
    lastName: lastNameField.value,
    email: emailField.value,
    additionalInformation: additionalInformationField.value,
    legalAccepted: legalCheckbox.checked,
    nonce: ffDiscounthuntFreeNonce,
    action: 'gifthuntfree_ajax_frontend_action',
    gifthuntfreeAction: 'collect',
  }

  let ffDiscounthuntErrorCount = 0;

  // first name check
  if(ffDiscounthuntHunterData.firstName.length < 1 && ffDiscounthuntFreeSessionData.form_collect_first_name == 1){
    firstNameField.classList.add("ffDiscounthuntFieldError");
    ffDiscounthuntErrorCount++;
  } else {
    firstNameField.classList.remove("ffDiscounthuntFieldError");
  }

  // last name check
  if(ffDiscounthuntHunterData.lastName.length < 1 && ffDiscounthuntFreeSessionData.form_collect_last_name == 1){
    lastNameField.classList.add("ffDiscounthuntFieldError");
    ffDiscounthuntErrorCount++;
  } else {
    lastNameField.classList.remove("ffDiscounthuntFieldError");
  }

  // email check
  if(ffDiscounthuntHunterData.email.length < 1 || (!/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(ffDiscounthuntHunterData.email))){
    emailField.classList.add("ffDiscounthuntFieldError");
    ffDiscounthuntErrorCount++;
  } else {
    emailField.classList.remove("ffDiscounthuntFieldError");
  }

  // legal checkbox check
  if(!legalCheckbox.checked){
    document.querySelector("#ff-discounthunt-free-session-form__group--legal a").classList.add("ffDiscounthuntFieldErrorText");
    ffDiscounthuntErrorCount++;
  } else {
    document.querySelector("#ff-discounthunt-free-session-form__group--legal a").classList.remove("ffDiscounthuntFieldErrorText");
  }

  if(ffDiscounthuntErrorCount){
    return;
  }

  /**
   * Disable button
   */
  ffDiscounthuntSubmitButton.disabled = true;

  /**
   * Display spinner
   */
  ffDiscounthuntSubmitButtonSpinner.classList.remove('ff-discounthunt-free-session--hidden');

  /**
   * Send data to backend
   */
  const ffDiscounthuntXHR = ffDiscounthuntFreeCreateCORSRequest("POST", ffDiscounthuntFreeApiEndpoint);
	if (!ffDiscounthuntXHR) {
		ffDiscounthuntSubmitButton.disabled = false;
		ffDiscounthuntSubmitButtonSpinner.classList.add('ff-discounthunt-free-session--hidden');
		alert("Something went wrong. Please refresh the page and try again.");
		return;
  }
  
  ffDiscounthuntXHR.setRequestHeader("X-Custom-Header", ffDiscounthuntFreeNonce);
	ffDiscounthuntXHR.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

	ffDiscounthuntXHR.onload = function() {
    const response = JSON.parse(ffDiscounthuntXHR.responseText);
    ffDiscounthuntSubmitButton.disabled = false;
    ffDiscounthuntSubmitButtonSpinner.classList.add('ff-discounthunt-free-session--hidden');
    
		if (response.status === "error" || !response) {
      /**
       * Error
       * - alert error
       */
      alert(response.data);
      return;
    } else if(response.status === "closed"){
      /**
       * Hunt session closed or out of dicsount codes
       * - hide modal
       * - delete cookie
       */
      ffToggleDiscountHuntSessionPopupFree();
      Cookies.remove(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`);
		} else {
			/**
       * Success
       * - Display result message
       * - Display discount code
       * - Change cookie params
       */
      document.querySelector("#ff-discounthunt-free-session-modal__form-container").classList.add("ff-discounthunt-free-session--hidden");
      document.querySelector("#ff-discounthunt-free-session-modal__description").classList.add("ff-discounthunt-free-session--hidden");
      document.querySelector("#ff-discounthunt-free-session-modal__result").classList.remove("ff-discounthunt-free-session--hidden");
      document.querySelector("#ff-discounthunt-free-session-modal__result-discountcode").innerHTML = response.data;

      const cookieValue = Cookies.getJSON(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`);

      let cookieDataFree = {
        cookieDate: Date.now(),
        sessionHuntId: cookieValue.sessionHuntId,
        codeFound: true,
        codeFoundDate: Date.now(),
        pageviews: 1,
        visitedPages: currentLocationFree
      }
    
      Cookies.set(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`, cookieDataFree, { expires: 365 });

      return;
		}
	};

	ffDiscounthuntXHR.onerror = function() {
		ffDiscounthuntSubmitButton.disabled = false;
    ffDiscounthuntSubmitButtonSpinner.classList.add('ff-discounthunt-free-session--hidden');
		alert("Something went wrong. Please refresh the page and try again.");
		return;
	};

	ffDiscounthuntXHR.send(
		Object.keys(ffDiscounthuntHunterData)
			.map(function(k) {
				return encodeURIComponent(k) + "=" + encodeURIComponent(ffDiscounthuntHunterData[k]);
			})
			.join("&")
	);

}

/**
 * Toggle discount hunt sesion popup
 */
const ffToggleDiscountHuntSessionPopupFree = () => {
  if(!document.body.classList.contains('ffDiscounthuntFrePopupVisible')){
    /**
     * Show popup
     */
    const ffDiscountHuntSessionPopupContaner = document.createElement('div');
    ffDiscountHuntSessionPopupContaner.style.cssText = `position: fixed; top: 0; left: 0; right: 0; bottom: 0; background: rgba(0, 0, 0, .6); z-index: 999999; overflow-y: auto; overflow-x: hidden;`;
    ffDiscountHuntSessionPopupContaner.setAttribute('id', 'ff-discounthunt-free-popup-root');
    ffDiscountHuntSessionPopupContaner.innerHTML = ffDiscounthuntFreePopupWindow;

    /**
     * Event listener for form submit
     */
    ffDiscountHuntSessionPopupContaner.querySelector("#ff-discounthunt-free-session-modal__form").addEventListener("submit", ffHandleDiscounthuntFormSubmitFree);

    /**
     * Add extra css to the head
     */
    if(!document.body.classList.contains('ffDiscounthuntFreePopupCSSAdded')){
      const ffDiscounthuntHead = document.head;
      let ffDiscounthuntExtraStyle = document.createElement('style');
      ffDiscounthuntHead.appendChild(ffDiscounthuntExtraStyle);
      ffDiscounthuntExtraStyle.type = 'text/css';
      if(ffDiscounthuntExtraStyle.styleSheet){
        ffDiscounthuntExtraStyle.styleSheet.cssText = ffDiscounthuntFreeCSS;
      } else {
        ffDiscounthuntExtraStyle.appendChild(document.createTextNode(ffDiscounthuntFreeCSS))
      }
      document.body.classList.add('ffDiscounthuntFreePopupCSSAdded');

      /**
       * Remove icon from site
       */
      const ffDiscounthuntIcon = document.querySelector("#ff-discounthunt-free-present-icon");
      ffDiscounthuntIcon.parentNode.removeChild(ffDiscounthuntIcon);
    }
    
    document.body.appendChild(ffDiscountHuntSessionPopupContaner);
    document.body.classList.add('ffDiscounthuntFrePopupVisible');
  } else {
    /**
     * Hide popup
     */
    const ffDiscounhuntPopupRoot = document.querySelector("#ff-discounthunt-free-popup-root");
    ffDiscounhuntPopupRoot.parentNode.removeChild(ffDiscounhuntPopupRoot);
    document.body.classList.remove('ffDiscounthuntFrePopupVisible');
  }
}

/**
 * Check session hunt cookie
 * Create if doesn't exists,
 * Update if exists
 */
let cookieDataFree = {
  cookieDate: currentTimeFree,
  sessionHuntId: ffDiscounthuntFreeSessionData.id,
  codeFound: false,
  pageviews: 1,
  visitedPages: currentLocationFree
}

/**
 * Add extra css to head
 */
const ffDiscounthuntSessionIconCssFree = () => {
  if(!document.body.classList.contains('ffDiscounthuntFreeIconCSSAdded')){
    const ffDiscounthuntHead = document.head;
    let ffDiscounthuntExtraStyle = document.createElement('style');
    ffDiscounthuntHead.appendChild(ffDiscounthuntExtraStyle);
    ffDiscounthuntExtraStyle.type = 'text/css';
    if(ffDiscounthuntExtraStyle.styleSheet){
      ffDiscounthuntExtraStyle.styleSheet.cssText = ffDiscounthuntFreeIconCSS;
    } else {
      ffDiscounthuntExtraStyle.appendChild(document.createTextNode(ffDiscounthuntFreeIconCSS))
    }
    document.body.classList.add('ffDiscounthuntFreeIconCSSAdded');
  }
}

const ffDiscounthuntInitFree = () => {
  if (!Cookies.get(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`) && !ffDiscounthuntFreeSessionPreview) {
    // doesn't exists, create it
    Cookies.set(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`, cookieDataFree, { expires: 365 });
  } else {
    // exists
    const cookieValue = Cookies.getJSON(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`);
  
    if(!ffDiscounthuntFreeSessionPreview){
      if(cookieValue.codeFound == true && ffDiscounthuntFreeSessionData.allow_multiple_collect != 1){
        /**
         * Found a code previously
         * Multiple collect is not allowed
         */
        return;
      }
    }

    // add icon css to head
    ffDiscounthuntSessionIconCssFree();
  
    const ffDiscountHuntPresentIcon = document.createElement('div');
    let iconTopPosition = 0;
    let iconLeftPosition = 0;

    if(ffDiscounthuntFreeSessionData.icon_placement && ffDiscounthuntFreeSessionData.icon_placement == "center"){
      iconTopPosition = Math.floor((winHeightFree - 80) / 2);
      iconLeftPosition = Math.floor((winWidthFree - 80) / 2);
    } else if(ffDiscounthuntFreeSessionData.icon_placement && ffDiscounthuntFreeSessionData.icon_placement == "bottom_left"){
      iconTopPosition = winHeightFree - 100;
      iconLeftPosition = 20;
    } else if(ffDiscounthuntFreeSessionData.icon_placement && ffDiscounthuntFreeSessionData.icon_placement == "bottom_right"){
      iconTopPosition = winHeightFree - 100;
      iconLeftPosition = winWidthFree - 100;
    } else {
      iconTopPosition = Math.floor(Math.random() * (winHeightFree - 120));
      iconLeftPosition = Math.floor(Math.random() * (winWidthFree - 120));
    }

    ffDiscountHuntPresentIcon.setAttribute('id', 'ff-discounthunt-free-present-icon');
    ffDiscountHuntPresentIcon.setAttribute('class', ffDiscounthuntFreeSessionData.icon_animation || 'pop');
    ffDiscountHuntPresentIcon.style.cssText = `top: ${iconTopPosition}px; left: ${iconLeftPosition}px;`;
    if(ffDiscounthuntFreeSessionData.icon == 99){
      ffDiscountHuntPresentIcon.innerHTML = `<a href="#"><div id="ff-discounthunt-free-icon-container"><img src="${decodeURIComponent(ffDiscounthuntFreeSessionData.custom_icon)}" alt="Gift Hunt Icon" /></div></a>`;
    } else {
      ffDiscountHuntPresentIcon.innerHTML = `<a href="#"><div id="ff-discounthunt-free-icon-container"><img src="${ffDiscounthuntFreeFrontendAssets}images/${ffDiscounthuntFreeSessionData.icon}.svg" alt="Gift Hunt Icon" /></div></a>`;
    }
    ffDiscountHuntPresentIcon.addEventListener('click', ffToggleDiscountHuntSessionPopupFree);

    if(!ffDiscounthuntFreeSessionPreview){
      // live
      if(ffDiscounthuntFreeSessionData.display_type == "time" && Math.floor((Date.now() - cookieValue.cookieDate) / 1000) >= ffDiscounthuntFreeSessionData.time_to_display){
        // user spent enough time on site to display present
        document.body.appendChild(ffDiscountHuntPresentIcon);
      } else if(ffDiscounthuntFreeSessionData.display_type == "pageview" && cookieValue.pageviews >= ffDiscounthuntFreeSessionData.pageview_to_display){
        // user viewed enough pages to display present
        document.body.appendChild(ffDiscountHuntPresentIcon);
      }

      // store visited pages
      const visitedPages = (!cookieValue.visitedPages.includes(currentLocationFree)) ? `${cookieValue.visitedPages}|${currentLocationFree}`: cookieValue.visitedPages;
    
      // count pageviews
      const visitedPagesArray = visitedPages.split("|")
      const pageviews = visitedPagesArray.length;
    
      cookieDataFree = {
        cookieDate: cookieValue.cookieDate,
        sessionHuntId: cookieValue.sessionHuntId,
        codeFound: cookieValue.codeFound,
        pageviews: pageviews,
        visitedPages: visitedPages
      }
    
      Cookies.set(`ffSessionHuntFreeCookie_${ffDiscounthuntFreeSessionData.id}`, cookieDataFree, { expires: 365 });
    } else {
      // preview, display icon
      document.body.appendChild(ffDiscountHuntPresentIcon);
    }
  }
}

window.onresize = () => {
  winWidthFree = window.innerWidth;
  winHeightFree = window.innerHeight;
}

document.body.addEventListener("click", (e) => {
  if(e.target.id == "ff-discounthunt-free-session-modal__close"){
    ffToggleDiscountHuntSessionPopupFree();
  }
});

ffDiscounthuntInitFree();